/*
 * File lex-test.c
 * Testing lexical.c
 *
 * The Unknown Scandinavian was here
 * 24-OCT-1990
 */

#include <stdio.h>
#include "lexical.h"

main (argc, argv)
     int argc;
     char *argv[];
{
  int t;
  
  if (argc != 2) 
    {
      fprintf (stderr, "Usage: %s <file>\n", argv[0]);
      exit (1);
    }
  newfile (argv[1]);
  
  while (1) 
    {
      t = token ();
      printf ("<%6d=%5d+%3d> %5d: ", token_byte, token_line,
	      token_col, token_count);
      switch (t) 
	{
	case TOKEN_EOF:
	  printf ("End of File\n\n");
	  printf ("%6d Bytes\n%6d Lines\n%6d Tokens\n",
		  token_byte, token_line, token_count);
	  nofile ();
	  exit (0);
	case TOKEN_NIL:
	  printf ("*** Illegal Lexeme\n"); break;
	case TOKEN_ASSIGN:
	  printf ("Assign\n"); break;
	case TOKEN_COLON:
	  printf ("Colon\n"); break;
	case TOKEN_COMMA:
	  printf ("Comma\n"); break;
	case TOKEN_DIGITS:
	  printf ("Digits: %d", token_int);
	  if (token_overflow)
	    printf (" *OVERFLOW*");
	  if (token_collision)
	    printf (" *TOKEN COLLISION*");
	  putchar ('\n');
	  break;
	case TOKEN_DIV:
	  printf ("Divide\n"); break;
	case TOKEN_DOT:
	  printf ("Fetch\n"); break;
	case TOKEN_ECOMM:
	  printf ("Embedded Comment: %d chars\n", token_int);
	  break;
	case TOKEN_LANG:
	  printf ("Left Angle Bracket\n"); break;
	case TOKEN_LBRACK:
	  printf ("Left Bracket\n"); break;
	case TOKEN_LPAREN:
	  printf ("Left Parenthesis\n"); break;
	case TOKEN_MINUS:
	  printf ("Minus\n"); break;
	case TOKEN_MUL:
	  printf ("Multiply\n"); break;
	case TOKEN_NAME:
	  printf ("Name <%s>", token_string);
	  if (token_overflow)
	    printf (" *OVERFLOW* %d chars", token_int);
	  if (token_collision)
	    printf (" *TOKEN COLLISION*");
	  if (token_dollars)
	    printf (" *YOU WORK FOR DEC*");
	  putchar ('\n');
	  break;
	case TOKEN_PERC:
	  printf ("Percent\n"); break;
	case TOKEN_PLUS:
	  printf ("Plus\n"); break;
	case TOKEN_POW:
	  printf ("Power\n"); break;
	case TOKEN_RANG:
	  printf ("Right Angle Bracket\n"); break;
	case TOKEN_RBRACK:
	  printf ("Right Bracket\n"); break;
	case TOKEN_RPAREN:
	  printf ("Right Parenthesis\n"); break;
	case TOKEN_SEMI:
	  printf ("Semicolon\n"); break;
	case TOKEN_STRING:
	  printf ("Quoted String <%s>", token_string);
	  if (token_overflow)
	    printf (" *OVERFLOW* %d chars", token_int);
	  if (token_collision)
	    printf (" *TOKEN COLLISION*");
	  putchar ('\n');
	  break;
	case TOKEN_TCOMM:
	  printf ("Trailing Comment: %d chars\n", token_int);
	  break;
	default:
	  printf ("Very undefined value from token (): %d\n", t);
	  exit (1);
	}
    }
  
}
